package util;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

public class StringToObjectConverter {

	public static Object Convert(String valueAsString, Class withType) {
		if (withType == (boolean.class) || withType == (Boolean.class)) {
			return new Boolean(valueAsString);
		} else if (withType == (byte.class) || withType == (Byte.class)) {
			return new Byte(valueAsString);
		} else if (withType == (char.class) || withType == (Character.class)) {
			return new Character(valueAsString.charAt(0));
		} else if (withType == (double.class) || withType == (Double.class)) {
			return new Double(valueAsString);
		} else if (withType == (float.class) || withType == (Float.class)) {
			return new Float(valueAsString);
		} else if (withType == (int.class) || withType == (Integer.class)) {
			return new Integer(valueAsString);
		} else if (withType == (long.class) || withType == (Long.class)) {
			return new Long(valueAsString);
		} else if (withType == (short.class) || withType == (Short.class)) {
			return new Short(valueAsString);
		} else if (withType == (String.class)) {
			return valueAsString;
		} else { // Generische Objekterzeugung versuchen

			IllegalArgumentException oops;
			oops =
				new IllegalArgumentException(
					"unable to create Object with Type ["
						+ withType.getName()
						+ "] from String ["
						+ valueAsString
						+ "]");
			try // passenden Konstruktor (-> mit form. Param. String) suchen und 
				{ // versuchen diesen aufzurufen (-> mit akt. Param. { valueAsString })
				String[] actualParameter = { valueAsString };
				Class[] formalParameter = { String.class };
				Constructor constructor =
					withType.getConstructor(formalParameter);
				return constructor.newInstance(actualParameter);
			} catch (NoSuchMethodException e) {
				throw oops;
			} catch (InstantiationException e) {
				throw oops;
			} catch (InvocationTargetException e) {
				throw oops;
			} catch (IllegalAccessException e) {
				throw oops;
			}
		}
	}

	public static void main(String[] args) {
		// Erfolg
		System.out.println(
			"Must be 17: " + StringToObjectConverter.Convert("17", int.class));
		System.out.println(
			"Must be 17: "
				+ StringToObjectConverter.Convert("17", StringBuffer.class));
		System.out.println(
			"Must be Frame with Title 17: "
				+ StringToObjectConverter.Convert("17", java.awt.Frame.class));
		System.out.println(
			"Must be 17: "
				+ StringToObjectConverter.Convert("17", String.class));

		// Fehler
		try {
			System.out.println(
				StringToObjectConverter.Convert("17a", int.class));
		} catch (RuntimeException e) {
			System.out.println("Must be NumberFormatException: " + e);
		}
		try {
			System.out.println(
				StringToObjectConverter.Convert("test", Class.class));
		} catch (RuntimeException e) {
			System.out.println("Must be IllegalArgumentException: " + e);
		}
	}
}