package remote;
//// package-imports
import java.awt.Point;

import util.WindowCloseController;

/**-----------------------------------------------------------------------------------
@author		Nancy Schett (NS)
@java			Java v1.1.x - Metroworks CodeWarrior Pro 5, IDE4.04 
@project		Software-Praktikum
@copyright	Forschungsgruppe Requirements Engineering,
				Institut fuer Informatik, Universitaet Zuerich
@class		InputDevice
@version		1.0	-	NS,								2000-Februar-29; erste Version
--------------------------------------------------------------------------------------
*/
/** <BR> Intention: Die Klasse InputDevice selbst hat kaum eigene Funktionalitaet, sondern
integriert lediglich die einzelnen Bestandteile (view/controller und model
-> und <InputDeviceControlPanel>und <InputDeviceEngine>) der InputDevice und startet 
die InputDevice mittels der main-Methode. <BR>

<BR>Responsability: <BR>.
*/
public class InputDevice
	{
	
	//// Class variables
	
	//// Instance variables	
	private InputDeviceControlPanel ip;	/* speichert den ControlPanel (nur wegen WindowClosing)*/
	
	//// Construktors
	public static InputDevice newInstance()
		{ return new InputDevice(); }
	
	//// Construktors
	private InputDevice()
		{ this.start(); }
		
	//// Zugriffs-ZustandsMethoden
	/**	Post:	Startet das InputDevice. <BR>
		Prec:	-
	@param -
	@see - 
	@init	NS, 3-April-2000
	@curr	NS, 3-April-2000 */
	private void start()
		{
		// Taschenrechnerteile erzeugen und Rechner zusammensetzen
		// Model erzeugen
		InputDeviceEngine ie = new InputDeviceEngine();
		
		// View und Controller fr Model erzeugen
		this.ip= new InputDeviceControlPanel( ie );

		// positionieren und anzeigen
		this.ip.setLocation( new Point( 50, 50 ) );
		this.ip.show();
		
		new WindowCloseController( ip );
		}
		

	//// Zugriffs-ZustandsMethoden
	/**	Post:	Stopt das InputDevice. <BR>
		Prec:	-
	@param -
	@see - 
	@init	NS, 3-April-2000
	@curr	NS, 3-April-2000 */
	public void stop()
		{ this.ip.dispose(); }
		
	//// zu test-zwecken
	public static void main( String args[] )
		{ InputDevice.newInstance();}
	} 