package remote;

//// Java-Api-Importe
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Panel;


/**-----------------------------------------------------------------------------------
@author		Nancy Schett (NS)
@java			Java v1.1.x - Metroworks CodeWarrior Pro 5, IDE4.04 
@project		Software-Praktikum
@copyright	Forschungsgruppe Requirements Engineering,
				Institut fuer Informatik, Universitaet Zuerich
@class		InputDeviceControlPanel
@version		1.0	-	NS,								2000-March-29; erste Version
--------------------------------------------------------------------------------------
*/
/** <BR>
Intention: Gesamtbenutzerschnittstelle fuer den InputDevice. Integriert View 
[InputDeviceDisplay] und Controller [InputDeviceKeyPad] und registiert View als Observer 
beim Model [InputDeviceEngine]. <BR>

Responsabilites:<BR>.
@see		InputDeviceDisplay
@see		InputDeviceInformation
@see		InputDeviceEngine
@see		InputDeviceKeyPad*/
class InputDeviceControlPanel extends Frame
	{
	
	/**	Post:	Erzeugt und Initialisiert die Gesamtbenuzterschnittstelle fuer
				die InputDeviceEngine [ie]. <BR>
		Prec:	-

	@param	ie 	InputDeviceEngine fuer welche eine GUI erzeugt werden soll.
	@see	CalculatorEngine
	@init	NS, 19-Maerz-2000
	@curr	NS, 19-Maerz-2000 */
	InputDeviceControlPanel( InputDeviceEngine ie )
		{
		setResizable( false );
		setTitle( "InputDevice" );
		setFont( new Font( "Helvetica", Font.PLAIN, 14 ) );
		setLayout( new BorderLayout( 4, 4 ) );
		
		Panel p1 = new Panel();
		p1.setLayout(new FlowLayout(FlowLayout.LEFT, 10, 10)); 
		p1.add( new InputDeviceInformation(ie) );
		p1.add( new InputDeviceDisplay(ie) );
		add( p1, "North" );

		
		add( "West", new Label( "" ) );
		add( "East", new Label( "" ) );
		
    	add( "Center", new InputDeviceKeypad( ie ) );
    		
    	pack();
		}
	}