package remote;

//// Java-Api-Imports
import java.awt.Color;
import java.awt.Label;
import java.util.Observable;
import java.util.Observer;

/**-----------------------------------------------------------------------------------
@author		Nancy Schett (NS)
@java			Java v1.1.x - Metroworks CodeWarrior Pro 5, IDE4.04 
@project		Software-Praktikum
@copyright	Forschungsgruppe Requirements Engineering,
				Institut fuer Informatik, Universitaet Zuerich
@class		InputDeviceDisplay
@version		1.0	-	NS,								2000-Februar-29; erste Version
--------------------------------------------------------------------------------------
*/
/** <BR>
Intention: View fuer [InputDeviceEngine]. Stellt den aktuellen Wert im Akku des Rechners dar.
Wird immer vom Model [InputDeviceEngine] benachrichtigt, wenn sich dort etwas geaendert hat
und [InputDeviceEngine] neu dargestellt werden soll.<BR>

Responsability: <BR>.
*/
class InputDeviceDisplay extends Label implements Observer
	{
	
	/**	Post:	Erzeugt und initialisiert das Objekt. <BR>
		Prec:	ie <> null

	@param	ie 	Model fuer das Display.
	@init	NS, 19-Maerz-2000
	@curr	NS, 19-Maerz-2000 */
	InputDeviceDisplay( InputDeviceEngine ie)
		{
		super( "0000000", RIGHT );
		setBackground( Color.white );
		setForeground( Color.black );
		ie.addObserver( this );
		}
	
	
	/**	Post:	Initiiert die aenderung des angezeigten Werts im Display. <BR>
		Prec:	-

	@param	o 			Model, welches zur Aktualisierung auffordert/Absender der Nachricht.
	@param	aDouble 	Aktueller Wert des Akkus in der InputDeviceEngine.
	@init	NS, 19-Maerz-2000
	@curr	NS, 19-Maerz-2000 */
	public void update( Observable o, Object arg )
		{ this.setText( ((Op) arg).op() ); }
	}
