
package sopra;

// Java API Importe
import java.util.Date;

/**------------------------------------------------------------------------------------
@author		Nancy Schett (NS)
@java			Java v1.1.x - Metroworks CodeWarrior Pro 5.5, IDE4.04 
@project		Software-Praktikum
@copyright	Forschungsgruppe Requirements Engineering,
				Institut fuer Informatik, Universitaet Zuerich
@class		Order
@version		1.0	-	NS,								2000-Februar-29; erste Version
---------------------------------------------------------------------------------------
*/
/**<BR>Intention:<BR>
Die Klasse Order speichert die Angaben zu einer spezifischen Bestellung, die durch eine 
Bedienung mit Hilfe der zum System gehoerigen Erfassungsgeraete (InputDevice) aufgenommen 
wurde.<BR>

<BR>Responsabilities:<BR>
1. Speichert die Daten einer Bestellung.<BR>
2. Stellt die Daten einer Bestellung zur Verfuegung.<BR>*/ 

public class Order
	{
	//// class variables

	//// instance variables
	
	/** Erfassungsdatum mit Zeit (hh:mm:ss)*/
	public Date orderTime;
	
	/** Identifiziert den Agenten eindeutig*/
	public int agent;
	
	/** Identifiziert den Bestellort (Tisch, Gast) eindeutig*/
	public float origin;
	
	/** Bestellte Elemente */
	public int[] orderItems;
	
	//// constructors 
	public Order newInstance()
		{ return new Order(); }
		
	
	//// Zustands-Zugriffs-Methoden
	/**	Post:	Setter-Methode fr den Agent <BR>
		Prec:	-

	@param	anAgent	integer-Wert des Agents
	@see	-
	@init	NS, 13-April-2000
	@curr	NS, 13-April-2000 */
	public void setAgent( int anAgent )
		{ this.agent = anAgent; }

	/**	Post:	Setter-Methode fr orderTime <BR>
		Prec:	-

	@param	anOrderTime	OrderTime
	@see	-
	@init	NS, 13-April-2000
	@curr	NS, 13-April-2000 */	
	public void setOrderTime( Date anOrderTime )
		{ this.orderTime = anOrderTime; }

	/**	Post:	Setter-Methode fr origin <BR>
		Prec:	-

	@param	anOrigin	flaot-Wert des Origins
	@see	-
	@init	NS, 13-April-2000
	@curr	NS, 13-April-2000 */		
	public void setOrigin( float anOrigin )
		{ this.origin = anOrigin; }

	/**	Post:	Setter-Methode fr OrderItems <BR>
		Prec:	-

	@param	nOrderItems	int-Array der OrderItems
	@see	-
	@init	NS, 13-April-2000
	@curr	NS, 13-April-2000 */
	public void setOrderItems( int[] nOrderItems )
		{ this.orderItems = (int[]) nOrderItems.clone(); }
		

	/**	Post:	Antwortet mit dem Array-Element and der Stelle [index]. <BR>
		Prec:	-

	@param	index 	Index des Array-Elements, welches abgefragt werden soll.
	@init	NS, 13-April-2000
	@curr	NS, 13-April-2000 */
	public int orderItemAt( int index )
		{ return orderItems[index]; }		

	}

