package util;


import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;



/** Erzeugt aus Zeichenketten/Strings, welche [String]-Reprsentationen von Werten/Objekten
darstellen, Objekte der entsprechenden Klasse.   

@author		Stefan Berner (SB) 
@java		Java v1.1.x - Metroworks Code Warrior Pro 2
@project	Lato
@version	1.0 - SB, 17-April-1998
			1.1 - NS, 02-March-2000		public Attributierungen*/
public class StringToObjectConverter
	{
	
	// Class Variables
	
	// Instance Variables
	
	// Constructors
	
	// Class Methods
	
	/**	Post:	Antwortet mit einem aus der Zeichenkette [valueAsString] erzeugten Objekt
				der Klasse [withType].  Gelingt es nicht, aus der Zeichenkette ein Objekt
				zu erzeugen, so wird eine IllegalArgumentException geworfen. <BR>
		Prec:	Es existiert ein (sichtbarer) Konstruktor mit form. Param. [String]. 

	@param	valueAsString 	Die [String]-Reprsentation des zu erzeugenden Objekts.
	@param 	withType 		Die Klasse, fr welche aus dem String ein Objekt erzeugt werden soll. 
	@init	SB, 17-April-1998
	@curr	SB, 17-April-1998 */
	public static Object Convert( String valueAsString, Class withType )
		{
			if ( withType == (boolean.class)     || withType == (Boolean.class) )
				{ return new Boolean(valueAsString); }
			else if ( withType == (byte.class)   || withType == (Byte.class)  )
				{ return new Byte(valueAsString); }
			else if ( withType == (char.class)   || withType == (Character.class)  )
				{ return new Character(valueAsString.charAt(0)); }
			else if ( withType == (double.class) || withType == (Double.class)  )
				{ return new Double(valueAsString); }
			else if ( withType == (float.class)  || withType == (Float.class)  )
				{ return new Float(valueAsString); }
			else if ( withType == (int.class)    || withType == (Integer.class)  )
				{ return new Integer(valueAsString); }
			else if ( withType == (long.class)   || withType == (Long.class)  )
				{ return new Long(valueAsString); }
			else if ( withType == (short.class)  || withType == (Short.class)  )
				{ return new Short(valueAsString); }
			else if ( withType == (String.class) )
				{ return valueAsString; }		
			else
				{	// Generische Objekterzeugung versuchen
				
				IllegalArgumentException oops;
				oops = new IllegalArgumentException( "unable to create Object with Type ["+withType.getName()
													+"] from String ["+valueAsString+"]" );				
				try		// passenden Konstruktor (-> mit form. Param. String) suchen und 
					{ 	// versuchen diesen aufzurufen (-> mit akt. Param. { valueAsString })
					String[] actualParameter = { valueAsString };
					Class[] formalParameter = { String.class };
					Constructor constructor = withType.getConstructor( formalParameter );
					return constructor.newInstance( actualParameter );
					}
				catch ( NoSuchMethodException e )
					{ throw oops; }
				catch ( InstantiationException e )
					{ throw oops; }
				catch ( InvocationTargetException e )
					{ throw oops; }
				catch ( IllegalAccessException e )
					{ throw oops; }
				}
		}


	/**	Post:	Demo/Minitest der Klasse. <BR>
		Prec:	-

	@param	args 	Wird nicht benutzt.
	@init	SB, 17-April-1998
	@curr	SB, 17-April-1998 */
	public static void main( String[] args )
		{
		// Erfolg
		System.out.println( "Must be 17: " + StringToObjectConverter.Convert( "17", int.class ) );
		System.out.println( "Must be 17: " + StringToObjectConverter.Convert( "17", StringBuffer.class ) );
		System.out.println( "Must be Frame with Title 17: " + StringToObjectConverter.Convert( "17", java.awt.Frame.class ) );
		System.out.println( "Must be 17: " + StringToObjectConverter.Convert( "17", String.class ) );		
		
		// Fehler
		try
			{ System.out.println( StringToObjectConverter.Convert( "17a", int.class ) ); }
		catch( RuntimeException e )
			{ System.out.println( "Must be NumberFormatException: " + e ); }
		try
			{ System.out.println( StringToObjectConverter.Convert( "test", Class.class) ); }
		catch( RuntimeException e )
			{ System.out.println( "Must be IllegalArgumentException: " + e ); }
		}
	
	// Instance Methods 
	
	}