package util;


import java.awt.Window;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;



/** Schliesst ein zu steuernes Fenster nachdem der Schliessknopf gedrckt wurde.
Die Klasse realisiert einen generischen Controller, welcher auf ein Ereigniss
zum Schliessen eines Fensters hin, das betreffende Fenster schliesst.

@see java.awt.events.WindowListener
@see java.awt.events.WindowAdapter
@see java.awt.events.WindowEvent
@see java.awt.Frame
@author		Stefan Berner
@java		Metroworks Java V1.1.1b3
@project	Lato
@version:	1.0, SB - 29-Jan-1998, erste Version */
public class WindowCloseController extends WindowAdapter
	{

	/** Das zu steuernde Fenster */
	final protected Window controlledWindow;
	

	/**	Post:	Richtet ein Steuerobjekt fuer das Fenster [windowToControl] ein.<BR>
		Prec:	[windowToControl] != null
		
	@param	windowToControl  Das Fenster, fr welches das Schliessereignis zu steuern ist.
	@init	SB, 23-Juli-1997
	@curr	SB, 29-Januar-1998 */
	public WindowCloseController( Window windowToControl )
		{
		this.controlledWindow = windowToControl;
		this.controlledWindow.addWindowListener( this );
		}


	/**	Post:	Schliesst das zu steuernde Fenster [controlledWindow] und gibt dessen
				Resourcen wieder frei.
		Prec:	-

	@param	anEvent  Ergeignisobjekt mit Absenderinformationen
	@see	java.awt.event.WindowEvent
	@init	SB, 23-Juli-1997
	@curr	SB, 25-Juli-1997 */
	public void windowClosing( WindowEvent anEvent )
 		{
		if ( anEvent.getWindow() == controlledWindow )
			{ // Absender = zu steuerndes Fenster, dann Fenster schliessen
			controlledWindow.setVisible( false );
			controlledWindow.dispose();
			}
 		}
    
	}
