package sopra;

import java.util.Calendar;
import java.util.GregorianCalendar;

public class Article {
	//Alle aktuellen Preise
	private float[] currentPrices = new float[8];
	//Alle Standard-Preise
	private float[] standardPrices = new float[8];
	//Preise der letzten Periode
	private float[] oldPrices = new float[8];
	//Alle Verkaufsmengen, Normalisiert auf eine Stunde
	private float[] amountsSold = new float[8];
	private float[] revenue = new float[8];
	private float standardPrice;
	private float standardAmountSold;
	private float lowerBoundary;
	private float upperBoundary;
	private float cost;
	private Calendar nextOrder; 
	private Calendar lastOrder;
	
	//Constructor
	public Article(	float standardPrice, float standardAmountSold,
					float lowerBoundary, float upperBoundary,
					Calendar nextOrder) {
		
		//initialisiere Arrays
		for(int i=0;i<8;i++) {
			//setze alle 8 alten Preise auf den Startpreis
			oldPrices[i] = standardPrice;
			
			//setze alle 8 alten Preise auf den Startpreis
			standardPrices[i] = standardPrice;
			
			//setze alle 8 currentPrices auf den Startpreis
			currentPrices[i] = standardPrice;
			
			//setze verkaufte Mengen des letzten Intervalls auf 0
			//amountsSold[i] = 0f;
			amountsSold[i] = standardAmountSold;
			
			//Setze totale Einknfte auf 0
			revenue[i] = 0f;
		}
		
		//initialisiere restliche Attribute
		this.standardPrice = standardPrice;
		this.standardAmountSold = standardAmountSold;
		this.lowerBoundary = lowerBoundary;
		this.upperBoundary = upperBoundary;
		this.nextOrder = nextOrder;
		cost = lowerBoundary;
		lastOrder = new GregorianCalendar(2004,6,22,11,00);
	}
	
	//Liefert die Zeit der nchsten Bestellung
	public Calendar getOrderTime() {
		return nextOrder;
	}
	
	//Liefert die Zeit der nchsten Bestellung
	public Calendar getLastOrderTime() {
		return lastOrder;
	}
	
	public float getStandardPrice() {
		return standardPrice;
	}
	
	public float getLowerBoundary() {
		return lowerBoundary;
	}
	
	public float getUpperBoundary() {
		return upperBoundary;
	}
	
	public float getStandardAmountSold() {
		return standardAmountSold;
	}
	
	public float[] getOldPrices() {
		return oldPrices;
	}

	public float[] getStandardPrices() {
		return standardPrices;
	}
	
	public float[] getCurrentPrices() {
		return currentPrices;
	}
	
	//speichert die in der letzten Periode verkauften Mengen,
	//hochgerechnet auf eine Stunde
	public float[] getAmountsSold() {
		return amountsSold;
	}
	
	public float getCost() {
		return cost;
	}
	
	public void setOldPrice(float price, int index) {
		oldPrices[index] = price;
	}

	public void setStandardPrice(float price, int index) {
		standardPrices[index] = price;
	}
	
	public void setPrice(float price, int index) {
		currentPrices[index] = price;
	}
	
	public void setAmount(float amount, int index) {
			amountsSold[index] = amount;
		}
	
	public void setLastOrder(Calendar lastOrder) {
		this.lastOrder = lastOrder;
	}
	
	public void setNextOrder(Calendar nextOrder) {
		this.nextOrder = nextOrder;
	}
	
	public void setStandardAmountSold(float newAmount) {
		this.standardAmountSold = newAmount;
	}
}
