package sopra;

/* Generated by Together */

/**
 * Moloch
 */

//package moloch.boersencafe.engine;

import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Random;
import java.util.Vector;

/**
 * Berechnet den Preis fr ein Produkt
 * 
 * @author Moloch
 * @version 1.0 
 * @history: 2004-06-05 MO First Version
 * @history: 2004-06-15 KR Kommentare
 * @responsibilities: ist fr die Preisberechnung verantwortlich
 */
public class PriceCalculator4 {
	
	public static int upSens = 2;
	public static int downSens = 8;
	public static boolean demo = false;
	
	private int amount = 0;

	/**
	 * @supplierCardinality 1
	 * @clientCardinality 0..1 
	 */
	//private BestellungManager bm;

	/**
	 * @supplierCardinality 1
	 * @clientCardinality 0..1
	 * @label bentigt Daten 
	 */
	//private ProduktManager pm;
    
	private Calendar lastOrderTimeStamp = null; 

	
   /**
	* PriceCalculatorinstanz
	*/
	private static PriceCalculator4 pc = null;
	/**
	 * Vektor mit der in der Brse enthaltenen Produkten
	 */
	private Vector lastAmount = new Vector();
	/**
	 * Statistikinstanz
	 */
	//private Statistik stat = Statistik.getInstance();
	
	/**
	 * gibt ein PreiceCalculatorobjekt zurck, falls es noch nicht
	 * eines gibt
	 * @return pc
	 */
	
	public PriceCalculator4(int startAmount){
		lastOrderTimeStamp = new GregorianCalendar();
		this.amount = startAmount;

	}
	public PriceCalculator4(){
		this(0);
		Random r = new Random();
		upSens = r.nextInt(10);
		downSens = r.nextInt(15)+5;
	}
	
	public static PriceCalculator4 getInstance(){
		
		if(pc == null){
			
			pc = new PriceCalculator4(0);
		
		}
		return pc;
	
	}
	/**
	 * berechnet den Konsum des Produktes beim letzten Zeitpunkt
	 * und lsst diesen Betrag in die Preisberechnung einfliessen
	 * @param productId ist das Produkt von der man den Preis berechnet
	 *
	public void calculatePrice(int productId){
		
		//int amount = 0;
		int vectorId = 0;
		boolean found = false;
		HelpProduct p;
		
		Produkt pr = ProduktManager.getInstance().getProdukt(productId);
		
		if(pr != null){
			
			int amountSold = stat.showVerbrauchArtikel(pr.getID())-amount;
			//System.out.println("amountSold: "+amountSold);
			amount += amountSold;
			double standardAmount = ProduktManager.getInstance().getStandardUmsatz(pr);
			//System.out.println("StandardAmount :"+standardAmount);
			float varpreis = calculatePrice((float)pr.getFixpreis(),(float)pr.getPreis(),(float)pr.getMinpreis(),(float)pr.getMaxpreis(),amountSold,(float)standardAmount,(Calendar)(new GregorianCalendar()));
			pr.setVarpreis((double)varpreis);
			ProduktManager.getInstance().save(pr);
			/*p = new HelpProduct(pr);
			for(int i=0;i<lastAmount.size();i++){
				
				if(((HelpProduct)(lastAmount.get(i))).getID() == p.getID()){
					
					amount = ((HelpProduct)(lastAmount.get(i))).getAmount();
					found = true;
					vectorId = i;
					
				}
			
			}
			if(!found){
				
				lastAmount.add(p);
				vectorId = lastAmount.indexOf(p);
				amount = 0;
			
			}
			
			
			int sold = stat.showVerbrauchArtikel(productId);
			int periodAmount = sold-amount;
			
			((HelpProduct)(lastAmount.get(vectorId))).setAmount(sold);
			float varpreis = calculatePrice((float)p.getFixpreis(),(float)p.getVarpreis(),(float)p.getMinpreis(),(float)p.getMaxpreis(),periodAmount,(float)10,(Calendar)(new GregorianCalendar()));
			p.setVarpreis((double)varpreis);
			ProduktManager.getInstance().save(p.getProduct());
			
			((HelpProduct)(lastAmount.get(vectorId))).setAmount(sold);
			
		}
	
	}*/
	
	/**
	 * berechnet den variablen Preis eines Produkts
	 * 
	 * 
	 * @post this.varpreis= newPrice
	 * 
	 * @param standardPrice Fixpreis
	 * @param currentPrice momentane Preis
	 * @param lowerBoundary Minimalpreis
	 * @param upperBoundary Maximalpreis
	 * @param amountSold verkaufte Menge
	 * @param standardAmountPerHour durchschnittlich verkaufte Menge pro Stunde
	 * @param timeStamp Zeitpunkt
	 * @return newPrice der neue Preis des Produkts
	 */
	public float calculatePrice(float standardPrice, float currentPrice, float lowerBoundary, float upperBoundary, int amountSold, float standardAmountPerHour, Calendar timeStamp) {
        
		float upTendency = 1;
		float downTendency = 1;
		
		float upSensitivity = (float)upSens/100;
		float downSensitivity = (float)downSens/100;
		
		float upStep = 1;
		float downStep = 1;
		
		float newPrice = currentPrice;
		
		float amountRatio = 0;
		
		float perHourSold = 0;
		
		if(currentPrice == 0){
		
			currentPrice = standardPrice;
			
		}
		if(amountSold > 0){
			float priceRatio = currentPrice/standardPrice;
			System.out.println("PriceRatio: "+priceRatio);
			
			long intervall = timeStamp.getTimeInMillis() - lastOrderTimeStamp.getTimeInMillis() ;
			
			lastOrderTimeStamp = timeStamp;
			
			float seconds = intervall/1000;
			float minutes = 0.0F;
			if(demo){
				minutes = seconds/(float)60;
				}else{
			minutes = intervall/1000;
			}
			float hours = minutes/(float)60;
			
			//System.out.println("Intervall: " + intervall+" seconds: "+seconds+" minutes: "+minutes+" hours: "+hours);
			
			perHourSold = (amountSold/hours);
			//System.out.println("perHourSold: " + perHourSold);
			
			amountRatio = perHourSold/standardAmountPerHour;
			//System.out.println("amountRatio: " + amountRatio+" standardAmountPerHour: "+standardAmountPerHour);
		}

		if(perHourSold <= standardAmountPerHour){
			upStep = (upperBoundary-currentPrice)*upSensitivity;
			newPrice = currentPrice + ((1-amountRatio)*upStep);
		}
		else if(perHourSold > standardAmountPerHour){
			downStep = (lowerBoundary-currentPrice)*downSensitivity;
			newPrice = currentPrice + (amountRatio*downStep);
		}
		
		//if(currentPrice > standardPrice){
			

		//downSensitivity = downSensitivity*(1/amountRatio);

		
		//}
		//else if(currentPrice < standardPrice){
			
		//upSensitivity = upSensitivity *amountRatio;
		
		//}
		/*
		if(perHourSold > standardAmountPerHour){
			downTendency = downTendency*downSensitivity;
		}
		else if(perHourSold < standardAmountPerHour){	
			upTendency = upTendency*upSensitivity;
		}
		
		newPrice = currentPrice*(upTendency/downTendency);
		System.out.println("New Price: "+ newPrice);
		*/
		if(newPrice > upperBoundary)
			newPrice = upperBoundary;
		if(newPrice < lowerBoundary)
			newPrice = lowerBoundary;
		
		
		return round(newPrice);
	}
	
	public float round(float tr){
		
		 float ret = 0;
	    	
			int r = (int)(tr*100);
			if(r%5 == 0){
	    		
				ret = ((float)r/(float)100);
	    	
			}else if(r%5 > 2){
	    		
				r = r+(5-(r%5));
				ret = ((float)r/(float)100);
	    	
			}else{
	    		
				r=r-(r%5);
				ret = ((float)r/(float)100);
	    	
			}
	    	
			return ret;
	
	}
	
}
/**
 * nested class
 * ist eine Hilfsklasse, die zum Berechnen des Preises eines Produkts
 * bentigt wird
 *
 */