package sopra;

/**
 * PHUMLAZ, INC
 */

import java.util.Calendar;
import java.util.Date;

public class PriceCalculator7 {

    private Calendar lastOrderTimeStamp;

    public float calculatePrice(float standardPrice,
                                float currentPrice,
                                float lowerBoundary,
                                float upperBoundary,
                                int amountSold,
                                float standardAmountPerHour,
                                Calendar timeStamp) {
    	float price, factor, amountPerHour;
    	long diff;
    	int iprice;
    	
    	if(currentPrice <= 0) {
    		currentPrice = standardPrice;
    	}
    	if (lowerBoundary > currentPrice)
    		currentPrice = lowerBoundary;
    	if (upperBoundary < currentPrice)
    		currentPrice = upperBoundary;

    	Calendar thisTime = Calendar.getInstance();
    	thisTime.setTime(new Date());
    	
    	diff = (thisTime.getTimeInMillis() - timeStamp.getTimeInMillis());
    	factor = (diff / 3600000f);
    	amountPerHour = amountSold / factor;
        
        if(amountPerHour > standardAmountPerHour) {
        	price = currentPrice - (float)Math.random() * ((currentPrice - lowerBoundary) / 2);
        }
        else {
			price = currentPrice + (float)Math.random() * ((upperBoundary - currentPrice) / 2);
        }
        
        price *= 100;
        iprice = (int)price;
        iprice = iprice /5;
        iprice *= 5;
        price = (float)iprice;
        price = price / 100;
        
        price = (price > upperBoundary) ? upperBoundary : price;
		price = (price < lowerBoundary) ? lowerBoundary : price;

		//System.out.println(standardPrice+" "+currentPrice+" "+lowerBoundary+" "+upperBoundary+" "+amountSold+" "+standardAmountPerHour+" => "+price);
        
    	return price;
    }
}
