package sopra;

public class WinnerDialog extends javax.swing.JDialog {
	private String team = null;
    
    /** Creates new form WinnerDialog */
    public WinnerDialog(java.awt.Frame parent, boolean modal, String team) {
        super(parent, modal);
        
        this.team = team;
        
        initComponents();
    }
    
    /** 
	 *	Initialize components
     */
    private void initComponents() {
        mainPane = new javax.swing.JPanel();
        iconPane = new javax.swing.JLabel();
        winnerPane = new javax.swing.JLabel();
		winnerName = new javax.swing.JLabel();

        setTitle("  And the winner is...");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        mainPane.setLayout(new java.awt.BorderLayout());

        mainPane.setBackground(new java.awt.Color(255, 255, 255));
        mainPane.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        iconPane.setBackground(new java.awt.Color(255, 255, 255));
        iconPane.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        iconPane.setIcon(new javax.swing.ImageIcon(getClass().getResource("/tasse.jpg")));
        iconPane.setPreferredSize(new java.awt.Dimension(400, 125));
        mainPane.add(iconPane, java.awt.BorderLayout.NORTH);

        winnerPane.setFont(new java.awt.Font("Dialog", 0, 24));
        winnerPane.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		winnerPane.setPreferredSize(new java.awt.Dimension(400, 50));
        winnerPane.setText("And the winner is...");
        mainPane.add(winnerPane, java.awt.BorderLayout.CENTER);

		winnerName.setFont(new java.awt.Font("Dialog", 1, 30));
		winnerName.setForeground(new java.awt.Color(153,0,0));
		winnerName.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		winnerName.setPreferredSize(new java.awt.Dimension(400, 75));
		winnerName.setText(this.team);
		mainPane.add(winnerName, java.awt.BorderLayout.SOUTH);

        getContentPane().add(mainPane, java.awt.BorderLayout.CENTER);

        pack();

		java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		setBounds((screenSize.width - this.getWidth()) / 2, (screenSize.height - this.getHeight()) / 2, this.getWidth(), this.getHeight());
    }
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new WinnerDialog(new javax.swing.JFrame(), true, "team").show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel iconPane;
    private javax.swing.JLabel winnerPane;
	private javax.swing.JLabel winnerName;
    private javax.swing.JPanel mainPane;
    // End of variables declaration//GEN-END:variables
    
}
